#ifndef	DEBUG_H
#define	DEBUG_H

#include <syslog.h>
#include <stdarg.h>

#define debug(category, fmt, ...) \
	((void)(twinstar_debug(LOG_DEBUG, DEBUG_CATEGORY_ ## category) && \
		twinstar_debug_print(LOG_DEBUG, "DBG(%s): %s: " fmt, \
			#category, __func__, ## __VA_ARGS__)))

#define	info(fmt, ...)	twinstar_debug_print(LOG_INFO, \
				"INFO: " fmt, ## __VA_ARGS__)
#define	warn(fmt, ...)	twinstar_debug_print(LOG_WARNING, \
				"WARN: " fmt, ## __VA_ARGS__)
#define	err(fmt, ...)	twinstar_debug_print(LOG_ERR, \
				"ERR(%s):" fmt, __func__, ## __VA_ARGS__)

enum debug_categories {
	DEBUG_CATEGORY_GENERAL,
	DEBUG_CATEGORY_CPG,
	DEBUG_CATEGORY_CPG_GLIB,
	DEBUG_CATEGORY_DBUS,
	DEBUG_CATEGORY_ASTRIBANKS,
	DEBUG_CATEGORY_TWINSTAR,
	DEBUG_CATEGORY_RUN,
	DEBUG_CATEGORY_LICENSE,
};

int twinstar_debug_syslog(const char *ident, const char *facility_name);
int twinstar_debug_redirect(const char *facility, const char *base_tag);
int twinstar_debug_print(int priority, const char *format, ...) __attribute__((format(printf, 2, 3)));
int twinstar_debug(int level, unsigned int category);
int twinstar_debug_get_level(void);
void twinstar_debug_set_level(int new_level);
unsigned int twinstar_debug_categories(void);
unsigned int twinstar_debug_get_categories(void);
void twinstar_debug_set_categories(unsigned int mask);

#endif	/* DEBUG_H */
