#ifndef	TWINSTAR_CPG_GLIB_H
#define	TWINSTAR_CPG_GLIB_H

#include <glib.h>
#include <glib-object.h>
#include "twinstar-cpg.h"

G_BEGIN_DECLS

struct twcpg_event_source {
        GSource gsource;        /* must be first */
	GPollFD gfd;
};

#define TWINSTAR_TYPE_CPG         (twcpg_glib_get_type ())
#define TWINSTAR_CPG(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), TWINSTAR_TYPE_CPG, TwinstarGCpg))
#define TWINSTAR_CPG_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), TWINSTAR_TYPE_CPG, TwinstarGCpgClass))
#define TWINSTAR_IS_CPG(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), TWINSTAR_TYPE_CPG))
#define TWINSTAR_IS_CPG_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), TWINSTAR_TYPE_CPG))
#define TWINSTAR_CPG_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), TWINSTAR_TYPE_CPG, TwinstarGCpgClass))

typedef struct TwinstarGCpgPrivate TwinstarGCpgPrivate;

typedef struct {
	GObject parent;
	TwinstarGCpgPrivate *priv;
} TwinstarGCpg;

typedef struct {
	GObjectClass             parent_class;
} TwinstarGCpgClass;

typedef enum {
	TWINSTAR_CPG_ERROR_GENERAL,
	TWINSTAR_CPG_NUM_ERRORS
} TwinstarGCpgError;


#define	TWINSTAR_CPG_ERROR	(twcpg_glib_error_quark ())
#define	TWINSTAR_CPG_TYPE_ERROR	(twcpg_glib_error_get_type ())

GQuark	twcpg_glib_error_quark(void);
GType	twcpg_glib_error_get_type(void);

TwinstarGCpg *twcpg_glib_new(gchar *name, struct twinstar_cpg_notify_ops *notify_ops, void *context);
int twcpg_glib_register(TwinstarGCpg *gcpg, GMainContext *mainctx);
int twcpg_glib_send_message(TwinstarGCpg *gcpg, const void *msg, size_t msg_len);
uint32_t twinstar_glib_local_nodeid(const TwinstarGCpg *gcpg);

G_END_DECLS

#endif	/* TWINSTAR_CPG_GLIB_H */
