#ifndef	TWINSTAR_CPG_H
#define	TWINSTAR_CPG_H

#include <stdint.h>
#include <sys/uio.h>

#define	MAX_NODEID	((uint32_t)(-1))

struct twinstar_cpg;

typedef	void (*notify_node_change_t)(void *context, uint32_t nodeid, size_t node_count);

struct twinstar_cpg_notify_ops {
	notify_node_change_t	joined;
	notify_node_change_t	left;
	void (*got_message)(void *context, uint32_t nodeid, void *msg, size_t msg_len);
};

uint32_t twinstar_cpg_local_nodeid(const struct twinstar_cpg *twcpg);

int twinstar_cpg_new(struct twinstar_cpg **twcpg_ptr, const char *gname, struct twinstar_cpg_notify_ops *notify_ops, void *context);
int twinstar_cpg_destroy(struct twinstar_cpg *twcpg);
int twinstar_cpg_send(struct twinstar_cpg *twcpg, const struct iovec iov[], size_t iov_len);
int twinstar_cpg_dispatch(struct twinstar_cpg *twcpg);
int twinstar_cpg_fd(struct twinstar_cpg *twcpg);

#endif	/* TWINSTAR_CPG_H */
