#ifndef	TWINSTAR_LICENSE_H
#define	TWINSTAR_LICENSE_H

#include <stdint.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define TWINSTAR_TYPE_LICENSE         (twinstar_license_get_type ())
#define TWINSTAR_LICENSE(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), TWINSTAR_TYPE_LICENSE, TwinstarLicense))
#define TWINSTAR_LICENSE_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), TWINSTAR_TYPE_LICENSE, TwinstarLicenseClass))
#define TWINSTAR_IS_LICENSE(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), TWINSTAR_TYPE_LICENSE))
#define TWINSTAR_IS_LICENSE_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), TWINSTAR_TYPE_LICENSE))
#define TWINSTAR_LICENSE_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), TWINSTAR_TYPE_LICENSE, TwinstarLicenseClass))

typedef struct TwinstarLicensePrivate TwinstarLicensePrivate;

typedef struct {
	GObject parent;
	TwinstarLicensePrivate *priv;
} TwinstarLicense;

typedef struct {
	GObjectClass             parent_class;
} TwinstarLicenseClass;

typedef enum {
	TWINSTAR_LICENSE_ERROR_GENERAL,
	TWINSTAR_LICENSE_NUM_ERRORS
} TwinstarLicenseError;


#define	TWINSTAR_LICENSE_ERROR		(twinstar_license_error_quark ())
#define	TWINSTAR_LICENSE_TYPE_ERROR	(twinstar_license_error_get_type ())

GQuark	twinstar_license_error_quark	(void);
GType	twinstar_license_error_get_type	(void);

struct twinstar_license_notify_ops {
	int (*cluster_license_notify)(void *context, gboolean license_ok, gboolean changed);
	int (*local_license_notify)(void *context, gboolean license_ok, gboolean changed);
};

TwinstarLicense *twinstar_license_new(const char *license_file, const char *license_name,
	const struct twinstar_license_notify_ops *notify_ops, void *context);
void twinstar_license_destroy(TwinstarLicense *twlicense);
int twinstar_license_joined(TwinstarLicense *twlicense, uint32_t nodeid);
int twinstar_license_left(TwinstarLicense *twlicense, uint32_t nodeid);
int twinstar_license_update(TwinstarLicense *twlicense, uint32_t nodeid, gboolean license_ok);
gboolean twinstar_license_ok(TwinstarLicense *twlicense);
void twinstar_license_dump(TwinstarLicense *twlicense);

int twinstar_license_validate_local(TwinstarLicense *twlicense);
void twinstar_license_periodic_validation(TwinstarLicense *twlicense, guint interval);

#define	LICENSE_PRODUCT		"twinstar-plus"

G_END_DECLS

#endif	/* TWINSTAR_LICENSE_H */
