#ifndef	TWINSTAR_RUN_H
#define	TWINSTAR_RUN_H

#include <glib-object.h>

G_BEGIN_DECLS

#define TWINSTAR_TYPE_RUN         (twinstar_run_get_type ())
#define TWINSTAR_RUN(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), TWINSTAR_TYPE_RUN, TwinstarRun))
#define TWINSTAR_RUN_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), TWINSTAR_TYPE_RUN, TwinstarRunClass))
#define TWINSTAR_IS_RUN(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), TWINSTAR_TYPE_RUN))
#define TWINSTAR_IS_RUN_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), TWINSTAR_TYPE_RUN))
#define TWINSTAR_RUN_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), TWINSTAR_TYPE_RUN, TwinstarRunClass))

typedef struct TwinstarRunPrivate TwinstarRunPrivate;

struct twinstar_run_notify_ops {
	void (*run_step_start)(void *context, const char *path, gboolean is_master, pid_t pid);
	void (*run_step_end)(void *context, const char *path, gboolean is_master, pid_t pid, int status);
	void (*run_steps_done)(void *context, int errors);
};

typedef struct {
	GObject parent;
	TwinstarRunPrivate *priv;
} TwinstarRun;

typedef struct {
	GObjectClass             parent_class;
} TwinstarRunClass;

typedef enum {
	TWINSTAR_RUN_ERROR_GENERAL,
	TWINSTAR_RUN_NUM_ERRORS
} TwinstarRunError;


#define	TWINSTAR_RUN_ERROR		(twinstar_run_error_quark ())
#define	TWINSTAR_RUN_TYPE_ERROR	(twinstar_run_error_get_type ())

GQuark	twinstar_run_error_quark	(void);
GType	twinstar_run_error_get_type	(void);

TwinstarRun *twinstar_run_new(const char *run_dir,
	const struct twinstar_run_notify_ops *notifications,
	void *context);
gboolean twinstar_run_start(TwinstarRun *twrun, gboolean master);
void twinstar_run_abort(TwinstarRun *twrun, int signum);

G_END_DECLS


#endif	/* TWINSTAR_RUN_H */
